"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var src_1 = require("../../src");
function isPromiseLike(result) {
    return result && typeof result.then === "function";
}
exports.isPromiseLike = isPromiseLike;
var ComputedAsync = (function () {
    function ComputedAsync(options) {
        var _this = this;
        this.options = options;
        this.status = src_1.observable({
            busy: false,
            failed: false,
            error: null
        });
        this.version = 0;
        this.atom = new src_1.Atom(function () { return _this.wake(); }, function () { return _this.sleep(); });
        this.cachedValue = options.init;
    }
    ComputedAsync.prototype.wake = function () {
        var _this = this;
        this.sleep();
        this.monitor = src_1.observe(function () { return _this.observe(); }, this.options.delay);
    };
    ComputedAsync.prototype.observe = function () {
        var _this = this;
        var thisVersion = ++this.version;
        if (this.options.revert) {
            this.cachedValue = this.options.init;
            this.atom.reportChanged();
        }
        var current = function (f) { return function (arg) {
            if (_this.version === thisVersion) {
                f(arg);
            }
        }; };
        try {
            var possiblePromise = this.options.fetch();
            if (!isPromiseLike(possiblePromise)) {
                this.stopped(false, undefined, possiblePromise);
            }
            else {
                this.starting();
                possiblePromise.then(current(function (v) { return _this.stopped(false, undefined, v); }), current(function (e) { return _this.handleError(e); }));
            }
        }
        catch (x) {
            this.handleError(x);
        }
    };
    ComputedAsync.prototype.starting = function () {
        this.status.busy = true;
    };
    ComputedAsync.prototype.stopped = function (f, e, v) {
        this.status.busy = false;
        this.status.failed = f;
        this.status.error = e;
        if (v !== this.cachedValue) {
            this.cachedValue = v;
            this.atom.reportChanged();
        }
    };
    ComputedAsync.prototype.handleError = function (e) {
        var newValue = this.options.init;
        if (this.options.error) {
            try {
                newValue = this.options.error(e);
            }
            catch (x) {
                //
            }
        }
        this.stopped(true, e, newValue);
    };
    ComputedAsync.prototype.sleep = function () {
        var monitor = this.monitor;
        this.monitor = undefined;
        if (monitor) {
            monitor.unobserve();
        }
    };
    Object.defineProperty(ComputedAsync.prototype, "value", {
        get: function () {
            this.atom.reportObserved();
            if (this.status.failed && this.options.rethrow) {
                throw this.status.error;
            }
            return this.cachedValue;
        },
        enumerable: true,
        configurable: true
    });
    __decorate([
        src_1.Action,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], ComputedAsync.prototype, "starting", null);
    __decorate([
        src_1.Action,
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Boolean, Object, Object]),
        __metadata("design:returntype", void 0)
    ], ComputedAsync.prototype, "stopped", null);
    return ComputedAsync;
}());
function computedAsync(init, fetch, delay) {
    if (arguments.length === 1) {
        return new ComputedAsync(init);
    }
    return new ComputedAsync({
        init: init,
        fetch: fetch,
        delay: delay
    });
}
exports.computedAsync = computedAsync;
//# sourceMappingURL=computed-async.js.map