"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var webpack = require("webpack");
var projectRoot = process.cwd();
var webpackConfig = {
    entry: path.join(__dirname, "../src/index.js"),
    output: {
        path: path.join(__dirname, ".."),
        filename: "bundle.js",
        libraryTarget: "umd"
    },
    module: {},
    plugins: [
        new webpack.DefinePlugin({
            "process.env": {
                NODE_ENV: JSON.stringify("production")
            }
        }),
        new webpack.HotModuleReplacementPlugin(),
        new webpack.NoEmitOnErrorsPlugin(),
        new webpack.optimize.UglifyJsPlugin({
            comments: false,
            mangle: false,
            compress: {
                warnings: false
            }
        })
    ],
    performance: {
        // 关闭性能提示
        hints: false,
    }
};
exports.default = webpackConfig;
//# sourceMappingURL=webpack.config.js.map