"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var global_state_1 = require("../global-state");
var native = WeakSet.prototype;
var getters = ["has"];
var all = ["add", "delete"].concat(getters);
function shim(target, bindCurrentReaction, queueRunReactions, proxyValue) {
    target.$raw = {};
    var _loop_1 = function (method) {
        // tslint:disable-next-line:space-before-function-paren only-arrow-functions
        target.$raw[method] = function () {
            native[method].apply(target, arguments);
        };
    };
    for (var _i = 0, all_1 = all; _i < all_1.length; _i++) {
        var method = all_1[_i];
        _loop_1(method);
    }
    var _loop_2 = function (getter) {
        // tslint:disable-next-line:space-before-function-paren only-arrow-functions
        target[getter] = function (value) {
            var result = native[getter].apply(this, arguments);
            global_state_1.globalState.event.emit("get", { target: target, key: null, value: result });
            result = proxyValue(this, value, result);
            bindCurrentReaction(this, value);
            return result;
        };
    };
    for (var _a = 0, getters_1 = getters; _a < getters_1.length; _a++) {
        var getter = getters_1[_a];
        _loop_2(getter);
    }
    // tslint:disable-next-line:space-before-function-paren only-arrow-functions
    target.add = function (value) {
        var has = this.has(value);
        var result = native.add.apply(this, arguments);
        global_state_1.globalState.event.emit("set", { target: target, key: null, value: value, oldValue: null });
        if (!has) {
            queueRunReactions(this, value);
        }
        return result;
    };
    // tslint:disable-next-line:space-before-function-paren only-arrow-functions
    target.delete = function (value) {
        var has = this.has(value);
        var result = native.delete.apply(this, arguments);
        global_state_1.globalState.event.emit("deleteProperty", { target: target, key: null });
        if (has) {
            queueRunReactions(this, value);
        }
        return result;
    };
    return target;
}
exports.default = shim;
//# sourceMappingURL=weak-set.js.map