"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Event = (function () {
    function Event() {
        // 所有事件
        this.events = new Map();
    }
    Event.prototype.on = function (eventType, callback) {
        var event = {
            callback: callback
        };
        if (this.events.get(eventType)) {
            // 存在, push 一个事件监听
            this.events.get(eventType).push(event);
        }
        else {
            // 不存在, 赋值
            this.events.set(eventType, [event]);
        }
    };
    /**
     * 取消订阅
     */
    Event.prototype.off = function (eventType, callback) {
        if (!this.events.get(eventType)) {
            return false;
        }
        var events = this.events.get(eventType).filter(function (event) {
            return event.callback !== callback;
        });
        this.events.set(eventType, events);
        return true;
    };
    /**
     * 广播事件
     */
    Event.prototype.emit = function (eventType, context) {
        if (!eventType || !this.events.get(eventType)) {
            return false;
        }
        this.events.get(eventType).forEach(function (event) {
            event.callback(context);
        });
    };
    return Event;
}());
exports.Event = Event;
//# sourceMappingURL=index.js.map