"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var global_state_1 = require("./global-state");
function isPrimitive(value) {
    if (value === null || value === undefined) {
        return true;
    }
    if (typeof value === "string" || typeof value === "number" || typeof value === "boolean" || value instanceof Date) {
        return true;
    }
    return false;
}
exports.isPrimitive = isPrimitive;
/**
 * Empty func.
 */
// tslint:disable-next-line:no-empty
exports.noop = function () { };
/**
 * Wether dob is in batch.
 */
function inAction() {
    return global_state_1.globalState.batchDeep !== 0;
}
exports.inAction = inAction;
/**
 * Is it currently in reaction?
 */
function inTrack() {
    return !!global_state_1.globalState.currentReaction;
}
exports.inTrack = inTrack;
/**
 * Get binder through object and key.
 */
function getBinder(object, key) {
    var keysForObject = global_state_1.globalState.objectReactionBindings.get(object);
    if (!keysForObject) {
        keysForObject = new Map();
        global_state_1.globalState.objectReactionBindings.set(object, keysForObject);
    }
    var reactionsForKey = keysForObject.get(key);
    if (!reactionsForKey) {
        reactionsForKey = new Set();
        keysForObject.set(key, reactionsForKey);
    }
    return {
        binder: keysForObject,
        keyBinder: reactionsForKey,
    };
}
exports.getBinder = getBinder;
function startDebug() {
    global_state_1.globalState.useDebug = true;
}
exports.startDebug = startDebug;
function stopDebug() {
    global_state_1.globalState.useDebug = false;
}
exports.stopDebug = stopDebug;
function useStrict() {
    global_state_1.globalState.strictMode = true;
}
exports.useStrict = useStrict;
function cancelStrict() {
    global_state_1.globalState.strictMode = false;
}
exports.cancelStrict = cancelStrict;
/**
 * create unique id
 */
function createUniqueId() {
    return global_state_1.globalState.uniqueIdCounter++;
}
exports.createUniqueId = createUniqueId;
//# sourceMappingURL=utils.js.map