"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var index_1 = require("../src/index");
var Clock = (function () {
    function Clock() {
        var _this = this;
        this.intervalHandler = null;
        this.currentDateTime = 1;
        this.atom = new index_1.Atom(function () { return _this.startTicking(); }, function () { return _this.stopTicking(); });
    }
    Clock.prototype.stopAtom = function () {
        this.atom.unobserve();
    };
    Clock.prototype.getTime = function () {
        this.atom.reportObserved();
        return this.currentDateTime;
    };
    Clock.prototype.startTicking = function () {
        this.currentDateTime++;
        this.atom.reportChanged();
    };
    Clock.prototype.stopTicking = function () {
        clearInterval(this.intervalHandler);
        this.intervalHandler = null;
    };
    return Clock;
}());
ava_1.default("basic test", function (t) {
    var time = 0;
    var clock = new Clock();
    index_1.observe(function () {
        time = clock.getTime();
    });
    clock.startTicking();
    clock.startTicking();
    clock.startTicking();
    return Promise.resolve()
        .then(function () { return t.true(time === 5); });
});
ava_1.default("unobservable", function (t) {
    var time = 0;
    var clock = new Clock();
    index_1.observe(function () {
        time = clock.getTime();
    });
    clock.startTicking();
    clock.startTicking();
    clock.stopAtom();
    return Promise.resolve()
        .then(function () { return t.true(time === 4); });
});
//# sourceMappingURL=atom.test.js.map