"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var event_1 = require("../src/event");
ava_1.default("test on", function (t) {
    var count = 0;
    var event = new event_1.Event();
    event.emit("change", 1);
    event.on("change", function (changedValue) {
        count += changedValue;
    });
    event.emit("change", 2);
    t.true(count === 2);
});
ava_1.default("test multiple on", function (t) {
    var count = 0;
    var event = new event_1.Event();
    event.emit("change", 1);
    event.on("change", function (changedValue) {
        count += changedValue;
    });
    event.on("change", function (changedValue) {
        count += changedValue;
    });
    event.emit("change", 2);
    t.true(count === 4);
});
ava_1.default("test off", function (t) {
    var count = 0;
    var event = new event_1.Event();
    event.emit("change", 1);
    function changeValue(changedValue) {
        count += changedValue;
    }
    event.on("change", changeValue);
    event.on("change", changeValue);
    event.emit("change", 2);
    event.off("change", changeValue);
    event.emit("change", 2);
    t.true(count === 4);
});
ava_1.default("test off not exist event", function (t) {
    var count = 0;
    var event = new event_1.Event();
    event.emit("change", 1);
    function changeValue(changedValue) {
        count += changedValue;
    }
    event.on("change", changeValue);
    event.on("change", changeValue);
    event.emit("change", 2);
    event.off("someThing", changeValue);
    event.emit("change", 2);
    t.true(count === 8);
});
//# sourceMappingURL=event.test.js.map