"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var index_1 = require("../src/index");
// /**
//  * observable
//  */
ava_1.default("should return a new observable when no argument is provided", function (t) {
    var dynamicObj = index_1.observable();
    t.true(index_1.isObservable(dynamicObj));
});
ava_1.default("should return an observable wrapping of an object argument", function (t) {
    var obj = { prop: "value" };
    var dynamicObj = index_1.observable(obj);
    t.false(obj === dynamicObj);
    t.true(index_1.isObservable(dynamicObj));
});
ava_1.default("should return the argument if test is already an observable", function (t) {
    var dynamicObj1 = index_1.observable();
    var dynamicObj2 = index_1.observable(dynamicObj1);
    t.true(dynamicObj1 === dynamicObj2);
});
ava_1.default("should return the same observable wrapper when called repeatedly with the same argument", function (t) {
    var obj = { prop: "value" };
    var dynamicObj1 = index_1.observable(obj);
    var dynamicObj2 = index_1.observable(obj);
    t.true(dynamicObj1 === dynamicObj2);
});
ava_1.default("should never modify the underlying plain object", function (t) {
    var obj = {};
    var dynamicObj = index_1.observable(obj);
    obj.nested1 = {};
    dynamicObj.nested2 = index_1.observable({});
    t.false(index_1.isObservable(obj.nested1));
    t.false(index_1.isObservable(obj.nested2));
});
ava_1.default("null throw typeError", function (t) {
    t.throws(function () {
        index_1.observable(null);
    }, TypeError);
});
ava_1.default("undefined not throw", function (t) {
    t.notThrows(function () {
        index_1.observable(undefined);
    });
});
ava_1.default("when observable class has constructor", function (t) {
    var MyCount = (function () {
        function MyCount(count1, count2) {
            this.count1 = count1;
            this.count2 = count2;
        }
        MyCount.prototype.getCount1 = function () {
            return this.count1;
        };
        MyCount.prototype.getCount2 = function () {
            return this.count2;
        };
        MyCount = __decorate([
            index_1.observable,
            __metadata("design:paramtypes", [Number, Number])
        ], MyCount);
        return MyCount;
    }());
    var myCount = new MyCount(3, 4);
    t.true(myCount.getCount1() === 3);
    t.true(myCount.getCount2() === 4);
});
/**
 * isObservable
 */
ava_1.default("should throw a TypeError on invalid arguments", function (t) {
    t.false(index_1.isObservable({}));
});
ava_1.default("should return true if an observable is passed as argument", function (t) {
    var dynamicObj = index_1.observable();
    t.true(index_1.isObservable(dynamicObj));
});
ava_1.default("should return false if a non observable is passed as argument", function (t) {
    var obj1 = { prop: "value" };
    var obj2 = new Proxy({}, {});
    t.false(index_1.isObservable(obj1));
    t.false(index_1.isObservable(obj2));
});
/**
 * Action
 */
ava_1.default("observe run sync", function (t) {
    var data = "";
    var dynamicObj = index_1.observable({ name: "b" });
    data += "a";
    index_1.observe(function () { return data += dynamicObj.name; });
    data += "c";
    return Promise.resolve()
        .then(function () { return t.true(data === "abc"); });
});
ava_1.default("observe run but not used", function (t) {
    var runCount = 0;
    var dynamicObj = index_1.observable({ name: "b" });
    index_1.observe(function () { return runCount++; });
    dynamicObj.name = "c";
    return Promise.resolve()
        .then(function () { return t.true(runCount === 1); });
});
ava_1.default("observe run any time", function (t) {
    var runCount = 0;
    var dynamicObj = index_1.observable({ name: "b" });
    index_1.observe(function () {
        runCount += 1;
        // use it!
        // tslint:disable-next-line:no-unused-expression
        dynamicObj.name;
    });
    dynamicObj.name = "c";
    dynamicObj.name = "d";
    return Promise.resolve()
        .then(function () { return t.true(runCount === 3); });
});
ava_1.default("Action", function (t) {
    var runCount = 0;
    var count = 0;
    var dynamicObj = index_1.observable({ number: 1 });
    index_1.observe(function () {
        runCount += 1;
        // use it!
        count += dynamicObj.number;
    });
    index_1.Action(function () {
        dynamicObj.number = 2;
        dynamicObj.number = 3;
    });
    return Promise.resolve()
        .then(function () { return t.true(runCount === 2); })
        .then(function () { return t.true(count === 4); }); // 1 + 3, do not use 2
});
/**
 * Action
 */
ava_1.default("Action with Action work", function (t) {
    var runCount = 0;
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    index_1.observe(function () {
        runCount++;
        data += dynamicObj.counter;
    });
    var MyAction = (function () {
        function MyAction() {
        }
        MyAction.prototype.run = function () {
            dynamicObj.counter = 1;
            dynamicObj.counter = 2;
        };
        __decorate([
            index_1.Action,
            __metadata("design:type", Function),
            __metadata("design:paramtypes", []),
            __metadata("design:returntype", void 0)
        ], MyAction.prototype, "run", null);
        return MyAction;
    }());
    new MyAction().run();
    return Promise.resolve()
        .then(function () { return t.true(runCount === 2); })
        .then(function () { return data = 2; }); // 0 + 2, ignore 1
});
ava_1.default("Action with params", function (t) {
    var runCount = 0;
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    index_1.observe(function () {
        runCount++;
        data += dynamicObj.counter;
    });
    var MyAction = (function () {
        function MyAction() {
        }
        MyAction.prototype.run = function (num) {
            dynamicObj.counter = num + 1;
            dynamicObj.counter = num + 1;
        };
        __decorate([
            index_1.Action,
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Number]),
            __metadata("design:returntype", void 0)
        ], MyAction.prototype, "run", null);
        return MyAction;
    }());
    new MyAction().run(1);
    return Promise.resolve()
        .then(function () { return t.true(runCount === 2); })
        .then(function () { return data = 3; }); // 0 + 3, ignore 2
});
ava_1.default("Action can get sync return value", function (t) {
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    index_1.observe(function () {
        data += dynamicObj.counter;
    });
    var MyAction = (function () {
        function MyAction() {
        }
        MyAction.prototype.run = function (num) {
            dynamicObj.counter = num + 1;
            return dynamicObj.counter;
        };
        __decorate([
            index_1.Action,
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Number]),
            __metadata("design:returntype", void 0)
        ], MyAction.prototype, "run", null);
        return MyAction;
    }());
    var result = new MyAction().run(1);
    return Promise.resolve()
        .then(function () { return t.true(result === 2); });
});
ava_1.default("Action can get async return value", function (t) {
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    index_1.observe(function () {
        data += dynamicObj.counter;
    });
    var MyAction = (function () {
        function MyAction() {
        }
        MyAction.prototype.run = function (num) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    dynamicObj.counter = num + 1;
                    return [2 /*return*/, dynamicObj.counter];
                });
            });
        };
        __decorate([
            index_1.Action,
            __metadata("design:type", Function),
            __metadata("design:paramtypes", [Number]),
            __metadata("design:returntype", Promise)
        ], MyAction.prototype, "run", null);
        return MyAction;
    }());
    var result = new MyAction().run(1);
    return Promise.resolve()
        .then(function () {
        return result.then(function (value) {
            t.true(value === 2);
        });
    });
});
/**
 * observe
 */
ava_1.default("should observe basic properties", function (t) {
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    index_1.observe(function () { return data = dynamicObj.counter; });
    return Promise.resolve()
        .then(function () { return t.true(data === 0); })
        .then(function () { return dynamicObj.counter = 7; })
        .then(function () { return t.true(data === 7); });
});
ava_1.default("should observe delete operations", function (t) {
    var data = "";
    var dynamicObj = index_1.observable({ prop: "value" });
    index_1.observe(function () { return data = dynamicObj.prop; });
    return Promise.resolve()
        .then(function () { return t.true(data === "value"); })
        .then(function () { return delete dynamicObj.prop; })
        .then(function () { return t.true(data === undefined); });
});
ava_1.default("should observe properties on the prototype chain", function (t) {
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    var parentDynamicObj = index_1.observable({ counter: 2 });
    Object.setPrototypeOf(dynamicObj, parentDynamicObj);
    index_1.observe(function () { return data = dynamicObj.counter; });
    return Promise.resolve()
        .then(function () { return t.true(data === 0); })
        .then(function () { return delete dynamicObj.counter; })
        .then(function () { return t.true(data === 2); })
        .then(function () { return parentDynamicObj.counter = 4; })
        .then(function () { return t.true(data === 4); })
        .then(function () { return dynamicObj.counter = 3; })
        .then(function () { return t.true(data === 3); });
});
ava_1.default("should observe function call chains", function (t) {
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    index_1.observe(function () { return data = getCounter(); });
    function getCounter() {
        return dynamicObj.counter;
    }
    return Promise.resolve()
        .then(function () { return t.true(data === 0); })
        .then(function () { return dynamicObj.counter = 2; })
        .then(function () { return t.true(data === 2); });
});
ava_1.default("should observe for of iteration", function (t) {
    var data = "";
    var dynamicObj = index_1.observable({ array: ["Hello"] });
    index_1.observe(function () { return data = dynamicObj.array.join(" "); });
    return Promise.resolve()
        .then(function () { return t.true(data === "Hello"); })
        .then(function () { return dynamicObj.array.push("World!"); })
        .then(function () { return t.true(data === "Hello World!"); })
        .then(function () { return dynamicObj.array.shift(); })
        .then(function () { return t.true(data === "World!"); });
});
// // test('should observe for in iteration', t => {
// //     let data = 0
// //     const dynamicObj: any = observable({prop: 0})
// //     observe(() => {
// //         data = 0
// //         for (let key in dynamicObj) {
// //             data += dynamicObj[key]
// //         }
// //     })
// //
// //     return Promise.resolve()
// //         .then(() => t.true(data === 0))
// //         .then(() => dynamicObj.prop = 1)
// //         .then(() => t.true(data === 1))
// //         .then(() => dynamicObj.prop1 = 1)
// //         .then(() => t.true(data === 2))
// //         .then(() => dynamicObj.prop2 = 3)
// //         .then(() => t.true(data === 5))
// //         .then(() => dynamicObj.prop1 = 6)
// //         .then(() => t.true(data === 10))
// // })
// // test('should not observe well-known symbols', t => {
// //     let data = ''
// //     const dynamicObj = observable({[Symbol.toStringTag]: 'myString'})
// //     observe(() => data = String(dynamicObj))
// //
// //     return Promise.resolve()
// //         .then(() => expect(data).to.equal('[object myString]'))
// //         .then(() => dynamicObj[Symbol.toStringTag] = 'otherString')
// //         .then(() => expect(data).to.equal('[object myString]'))
// // })
ava_1.default("should not observe set operations without a value change", function (t) {
    var data = "";
    var dynamicObj = index_1.observable({ prop: "prop" });
    var numOfRuns = 0;
    function testObserve() {
        data = dynamicObj.prop;
        numOfRuns++;
    }
    index_1.observe(testObserve);
    return Promise.resolve()
        .then(function () { return t.true(data === "prop"); })
        .then(function () { return dynamicObj.prop = "prop"; })
        .then(function () {
        t.true(numOfRuns === 1);
        t.true(data === "prop");
    })
        .then(function () { return dynamicObj.prop = "prop2"; })
        .then(function () { return dynamicObj.prop = "prop2"; })
        .then(function () {
        t.true(numOfRuns === 2);
        t.true(data === "prop2");
    });
});
ava_1.default("should run synchronously after registration", function (t) {
    var data = "";
    var dynamicObj = index_1.observable({ prop: "prop" });
    var numOfRuns = 0;
    index_1.observe(function () {
        data = dynamicObj.prop;
        numOfRuns++;
    });
    t.true(numOfRuns === 1);
    t.true(data === "prop");
    return Promise.resolve()
        .then(function () {
        t.true(numOfRuns === 1);
        t.true(data === "prop");
    })
        .then(function () {
        dynamicObj.prop = "new prop";
    })
        .then(function () {
        t.true(numOfRuns === 2);
        t.true(data === "new prop");
    });
});
ava_1.default("should rerun maximum once per stack", function (t) {
    var data = 0;
    var dynamicObj = index_1.observable({ prop1: 0, prop2: 0 });
    var numOfRuns = 0;
    function testObserve() {
        data = dynamicObj.prop1 + dynamicObj.prop2;
        numOfRuns++;
    }
    index_1.observe(testObserve);
    return Promise.resolve()
        .then(function () {
        t.true(numOfRuns === 1);
        t.true(data === 0);
    })
        .then(function () {
        index_1.Action(function () {
            dynamicObj.prop1 = 1;
            dynamicObj.prop2 = 3;
            dynamicObj.prop1 = 2;
        });
    })
        .then(function () {
        t.true(numOfRuns === 2);
        t.true(data === 5);
    });
});
ava_1.default("should avoid infinite loops", function (t) {
    var dynamicObj1 = index_1.observable({ prop: "value1" });
    var dynamicObj2 = index_1.observable({ prop: "value2" });
    var numOfRuns1 = 0;
    var numOfRuns2 = 0;
    function test1() {
        dynamicObj1.prop = dynamicObj2.prop;
        numOfRuns1++;
    }
    function test2() {
        dynamicObj2.prop = dynamicObj1.prop;
        numOfRuns2++;
    }
    index_1.observe(test1);
    index_1.observe(test2);
    return Promise.resolve()
        .then(function () { return dynamicObj1.prop = "Hello"; })
        .then(function () { return t.true(dynamicObj2.prop === "Hello"); })
        .then(function () { return dynamicObj1.prop = "World!"; })
        .then(function () { return t.true(dynamicObj2.prop === "World!"); })
        .then(function () {
        t.true(numOfRuns1 === 3);
        t.true(numOfRuns2 === 3);
    });
});
ava_1.default("should return an unobserve (object) signal", function (t) {
    var data = 0;
    var dynamicObj = index_1.observable({ counter: 0 });
    var signal = index_1.observe(function () { return data = dynamicObj.counter; });
    t.true(typeof signal === "object");
});
/**
 * set
 */
ava_1.default("set should observe string", function (t) {
    var data;
    var dynamicObj = index_1.observable(new Set());
    index_1.observe(function () { return data = dynamicObj.has("value"); });
    return Promise.resolve()
        .then(function () { return t.false(data); })
        .then(function () { return dynamicObj.add("value"); })
        .then(function () { return t.true(data); })
        .then(function () { return dynamicObj.delete("value"); })
        .then(function () { return t.false(data); });
});
ava_1.default("should observe iteration", function (t) {
    var data;
    var dynamicObj = index_1.observable(new Set());
    index_1.observe(function () {
        data = 0;
        dynamicObj.forEach(function (each) {
            data += each;
        });
    });
    return Promise.resolve()
        .then(function () { return t.true(data === 0); })
        .then(function () { return dynamicObj.add(3); })
        .then(function () { return t.true(data === 3); })
        .then(function () { return dynamicObj.add(2); })
        .then(function () { return t.true(data === 5); })
        .then(function () { return dynamicObj.delete(2); })
        .then(function () { return t.true(data === 3); })
        .then(function () { return dynamicObj.clear(); })
        .then(function () { return t.true(data === 0); });
});
ava_1.default("set delete test", function (t) {
    var data;
    var numOfRuns = 0;
    var dynamicObj = index_1.observable(new Set());
    index_1.observe(function () {
        numOfRuns++;
        data = dynamicObj.has("value");
    });
    return Promise.resolve()
        .then(function () {
        t.false(data);
        t.true(numOfRuns === 1);
    })
        .then(function () { return dynamicObj.add("value"); })
        .then(function () { return dynamicObj.add("value"); })
        .then(function () {
        t.true(data);
        t.true(numOfRuns === 2);
    })
        .then(function () { return dynamicObj.delete("value"); })
        .then(function () { return dynamicObj.delete("value"); })
        .then(function () {
        t.false(data);
        t.true(numOfRuns === 3);
    });
});
ava_1.default("should observe mutations", function (t) {
    var data;
    var value = {};
    var dynamicObj = index_1.observable(new Set());
    index_1.observe(function () { return data = dynamicObj.has(value); });
    return Promise.resolve()
        .then(function () { return t.false(data); })
        .then(function () { return dynamicObj.add(value); })
        .then(function () { return t.true(data); })
        .then(function () { return dynamicObj.delete(value); })
        .then(function () { return t.false(data); });
});
ava_1.default("should not observe non value changing mutations", function (t) {
    var data;
    var value = {};
    var numOfRuns = 0;
    var dynamicObj = index_1.observable(new Set());
    index_1.observe(function () {
        numOfRuns++;
        data = dynamicObj.has(value);
    });
    return Promise.resolve()
        .then(function () {
        t.false(data);
        t.true(numOfRuns === 1);
    })
        .then(function () { return dynamicObj.add(value); })
        .then(function () { return dynamicObj.add(value); })
        .then(function () {
        t.true(data);
        t.true(numOfRuns === 2);
    })
        .then(function () { return dynamicObj.delete(value); })
        .then(function () { return dynamicObj.delete(value); })
        .then(function () {
        t.false(data);
        t.true(numOfRuns === 3);
    });
});
/**
 * WeakSet
 */
ava_1.default("weakSet should observe object", function (t) {
    var data;
    var value = {};
    var dynamicObj = index_1.observable(new WeakSet());
    index_1.observe(function () { return data = dynamicObj.has(value); });
    return Promise.resolve()
        .then(function () { return t.false(data); })
        .then(function () { return dynamicObj.add(value); })
        .then(function () { return t.true(data); })
        .then(function () { return dynamicObj.delete(value); })
        .then(function () { return t.false(data); });
});
/**
 * Map
 */
ava_1.default("weakSet should observe string", function (t) {
    var data;
    var dynamicObj = index_1.observable(new Map());
    index_1.observe(function () { return data = dynamicObj.get("key"); });
    return Promise.resolve()
        .then(function () { return t.true(data === undefined); })
        .then(function () { return dynamicObj.set("key", "value"); })
        .then(function () { return t.true(data === "value"); })
        .then(function () { return dynamicObj.delete("key"); })
        .then(function () { return t.true(data === undefined); });
});
ava_1.default("should observe iteration", function (t) {
    var data;
    var dynamicObj = index_1.observable(new Map());
    index_1.observe(function () {
        data = 0;
        dynamicObj.forEach(function (each) {
            data += each;
        });
    });
    return Promise.resolve()
        .then(function () { return t.true(data === 0); })
        .then(function () { return dynamicObj.set("key0", 3); })
        .then(function () { return t.true(data === 3); })
        .then(function () { return dynamicObj.set("key1", 2); })
        .then(function () { return t.true(data === 5); })
        .then(function () { return dynamicObj.delete("key0"); })
        .then(function () { return t.true(data === 2); })
        .then(function () { return dynamicObj.clear(); })
        .then(function () { return t.true(data === 0); });
});
ava_1.default("should not observe non value changing mutations", function (t) {
    var data;
    var numOfRuns = 0;
    var dynamicObj = index_1.observable(new Map());
    index_1.observe(function () {
        numOfRuns++;
        data = dynamicObj.get("key");
    });
    return Promise.resolve()
        .then(function () {
        t.true(data === undefined);
        t.true(numOfRuns === 1);
    })
        .then(function () { return dynamicObj.set("key", "value"); })
        .then(function () { return dynamicObj.set("key", "value"); })
        .then(function () {
        t.true(data === "value");
        t.true(numOfRuns === 2);
    })
        .then(function () { return dynamicObj.delete("key"); })
        .then(function () { return dynamicObj.delete("key"); })
        .then(function () {
        t.true(data === undefined);
        t.true(numOfRuns === 3);
    });
});
ava_1.default("should observe map array", function (t) {
    var data;
    var dynamicObj = index_1.observable(new Map([
        ["a", [1, 2, 3]]
    ]));
    index_1.observe(function () { return data = dynamicObj.get("a").length; });
    return Promise.resolve()
        .then(function () { return t.true(data === 3); })
        .then(function () { return dynamicObj.get("a").push(4); })
        .then(function () { return t.true(data === 4); });
});
ava_1.default("should observe map.size", function (t) {
    var map = index_1.observable(new Map());
    var count = 0;
    index_1.observe(function () {
        count += map.size;
    });
    map.set("banana", 5);
    map.set("apple", 3);
    return Promise.resolve()
        .then(function () { return t.true(count === 3); });
});
/**
 * WeakMap
 */
ava_1.default("should observe mutations", function (t) {
    var data;
    var key = {};
    var dynamicObj = index_1.observable(new WeakMap());
    index_1.observe(function () { return data = dynamicObj.get(key); });
    return Promise.resolve()
        .then(function () { return t.true(data === undefined); })
        .then(function () { return dynamicObj.set(key, "value"); })
        .then(function () { return t.true(data === "value"); })
        .then(function () { return dynamicObj.delete(key); })
        .then(function () { return t.true(data === undefined); });
});
ava_1.default("should not observe non value changing mutations", function (t) {
    var data;
    var numOfRuns = 0;
    var key = {};
    var dynamicObj = index_1.observable(new WeakMap());
    index_1.observe(function () {
        numOfRuns++;
        data = dynamicObj.get(key);
    });
    return Promise.resolve()
        .then(function () {
        t.true(data === undefined);
        t.true(numOfRuns === 1);
    })
        .then(function () { return dynamicObj.set(key, "value"); })
        .then(function () { return dynamicObj.set(key, "value"); })
        .then(function () {
        t.true(data === "value");
        t.true(numOfRuns === 2);
    })
        .then(function () { return dynamicObj.delete(key); })
        .then(function () { return dynamicObj.delete(key); })
        .then(function () {
        t.true(data === undefined);
        t.true(numOfRuns === 3);
    });
});
/**
 * execution order
 */
ava_1.default("should run in runner order the first time", function (t) {
    var data = "";
    var dynamicObj = index_1.observable({ prop1: "prop1", prop2: "prop2", prop3: "prop3" });
    index_1.observe(function () { return data += dynamicObj.prop1; });
    index_1.observe(function () { return data += dynamicObj.prop2; });
    index_1.observe(function () { return data += dynamicObj.prop3; });
    dynamicObj.prop3 = "p3";
    dynamicObj.prop1 = "p1";
    dynamicObj.prop2 = "p2";
    return Promise.resolve()
        .then(function () { return t.true(data === "prop1prop2prop3p3p1p2"); });
});
/**
 * unobserve
 */
ava_1.default("should unobserve the observed function", function (t) {
    // TODO:
    // let data = ""
    // const dynamicObj = observable({ prop: "" })
    // let numOfRuns = 0
    // function testObserve() {
    //     data = dynamicObj.prop
    //     numOfRuns++
    // }
    // const signal = observe(testObserve)
    // return Promise.resolve()
    //     .then(() => dynamicObj.prop = "Hello")
    //     .then(() => signal.unobserve())
    //     .then(() => {
    //         t.true(signal.callback === undefined)
    //         t.true(signal.observedKeys === undefined)
    //     })
    //     .then(() => dynamicObj.prop = "World")
    //     .then(() => dynamicObj.prop = "!")
    //     .then(() => t.true(numOfRuns === 2))
});
ava_1.default("should not unobserve if the function is registered for the stack, because of sync", function (t) {
    var data;
    var dynamicObj = index_1.observable({ prop: 0 });
    var numOfRuns = 0;
    function testObserve() {
        data = dynamicObj.prop;
        numOfRuns++;
    }
    var signal = index_1.observe(testObserve);
    return Promise.resolve()
        .then(function () {
        dynamicObj.prop = 2; // but also run
        signal.unobserve();
    })
        .then(function () { return t.true(numOfRuns === 2); });
});
ava_1.default("should unobserve even if the function is registered for the stack, when use Action", function (t) {
    var data;
    var dynamicObj = index_1.observable({ prop: 0 });
    var numOfRuns = 0;
    function testObserve() {
        data = dynamicObj.prop;
        numOfRuns++;
    }
    var signal = index_1.observe(testObserve);
    return Promise.resolve()
        .then(function () {
        index_1.Action(function () {
            dynamicObj.prop = 2; // not run
            signal.unobserve();
        });
    })
        .then(function () { return t.true(numOfRuns === 1); });
});
ava_1.default("will trace dependency in anywhere", function (t) {
    var runCount = 0;
    var dynamicObj = index_1.observable({
        a: 0,
        b: 1
    });
    index_1.observe(function () {
        // use a
        // tslint:disable-next-line:no-unused-expression
        dynamicObj.a;
        runSomeThing();
        runCount++;
    });
    function runSomeThing() {
        // use b
        // tslint:disable-next-line:no-unused-expression
        dynamicObj.b;
    }
    dynamicObj.a = 2;
    dynamicObj.b = 3;
    return Promise.resolve()
        .then(function () { return t.true(runCount === 3); });
});
ava_1.default("Action will not trace dependency", function (t) {
    var runCount = 0;
    var dynamicObj = index_1.observable({
        a: 0,
        b: 1
    });
    index_1.observe(function () {
        // use a
        // tslint:disable-next-line:no-unused-expression
        dynamicObj.a;
        index_1.Action(function () {
            // tslint:disable-next-line:no-unused-expression
            dynamicObj.b;
        });
        runCount++;
    });
    dynamicObj.b = 2;
    return Promise.resolve()
        .then(function () { return t.true(runCount === 1); });
});
/**
 * Action handle async
 */
ava_1.default("Action not handle async function!!", function (t) {
    var runCount = 0;
    var num = 0;
    var dynamicObj = index_1.observable({
        a: 0,
        b: 1
    });
    index_1.observe(function () {
        // use a
        num = dynamicObj.a;
        runCount++;
    });
    index_1.Action(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dynamicObj.a = 1;
                    dynamicObj.a = 2;
                    return [4 /*yield*/, Promise.resolve()];
                case 1:
                    _a.sent();
                    dynamicObj.a = 3;
                    dynamicObj.a = 4;
                    dynamicObj.a = 5;
                    dynamicObj.a = 6;
                    return [2 /*return*/];
            }
        });
    }); });
    return Promise.resolve()
        .then(function () { return t.true(runCount === 6); })
        .then(function () { return t.true(num === 6); });
});
ava_1.default("Action handle async function with Action", function (t) {
    var runCount = 0;
    var num = 0;
    var dynamicObj = index_1.observable({
        a: 0,
        b: 1
    });
    index_1.observe(function () {
        // use a
        num = dynamicObj.a;
        runCount++;
    });
    index_1.Action(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    dynamicObj.a = 1;
                    return [4 /*yield*/, Promise.resolve()];
                case 1:
                    _a.sent();
                    index_1.Action(function () {
                        dynamicObj.a = 2;
                        dynamicObj.a = 3;
                        dynamicObj.a = 4;
                        dynamicObj.a = 5;
                    });
                    return [2 /*return*/];
            }
        });
    }); });
    return Promise.resolve()
        .then(function () { return t.true(runCount === 3); })
        .then(function () { return t.true(num === 5); });
});
/**
 * Branch judgment
 */
ava_1.default("branch judgment", function (t) {
    var value = 0;
    var runCount = 0;
    var dynamicObj = index_1.observable({
        a: true,
        b: 1,
        c: 2
    });
    index_1.observe(function () {
        runCount++;
        // tslint:disable-next-line:prefer-conditional-expression
        if (dynamicObj.a) {
            value = dynamicObj.b;
        }
        else {
            value = dynamicObj.c;
        }
    });
    return Promise.resolve()
        .then(function () { return t.true(value === 1); })
        .then(function () { return t.true(runCount === 1); })
        .then(function () { return dynamicObj.c = 3; }) // nothing happend
        .then(function () { return t.true(value === 1); })
        .then(function () { return t.true(runCount === 1); })
        .then(function () { return dynamicObj.a = false; })
        .then(function () { return t.true(value === 3); })
        .then(function () { return t.true(runCount === 2); })
        .then(function () { return dynamicObj.c = 4; })
        .then(function () { return t.true(value === 4); })
        .then(function () { return t.true(runCount === 3); })
        .then(function () { return dynamicObj.b = 5; })
        .then(function () { return t.true(value === 4); })
        .then(function () { return t.true(runCount === 3); });
});
/**
 * Static
 */
ava_1.default("Static will not tracking object", function (t) {
    var runCount = 0;
    var result = "";
    var dynamicObj = index_1.observable(index_1.Static({ name: "b" }));
    index_1.observe(function () {
        result = dynamicObj.name;
        runCount++;
    });
    dynamicObj.name = "c";
    return Promise.resolve()
        .then(function () { return t.true(runCount === 1); })
        .then(function () { return t.true(result === "b"); });
});
ava_1.default("Static will not tracking map", function (t) {
    var runCount = 0;
    var size = 0;
    var dynamicObj = index_1.observable(index_1.Static(new Map()));
    index_1.observe(function () {
        size = dynamicObj.size;
        runCount++;
    });
    dynamicObj.set("a", "a");
    dynamicObj.set("b", "b");
    return Promise.resolve()
        .then(function () { return t.true(runCount === 1); })
        .then(function () { return t.true(size === 0); });
});
ava_1.default("nested observe should eventually run", function (t) {
    var dynamicObj = index_1.observable({
        a: "1",
        b: "2",
        c: "3",
        d: "4"
    });
    var str = "";
    index_1.observe(function () {
        str += dynamicObj.a;
        index_1.observe(function () {
            str += 5;
            index_1.observe(function () {
                str += dynamicObj.b;
            });
            str += 6;
        });
        index_1.observe(function () {
            str += 8;
            index_1.observe(function () {
                str += dynamicObj.c;
            });
            str += 9;
        });
        str += dynamicObj.d;
    });
    dynamicObj.a = "2";
    return Promise.resolve()
        .then(function () { return t.true(str === "1456289324562893"); });
});
//# sourceMappingURL=observer.test.js.map