"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ava_1 = require("ava");
var index_1 = require("../src/index");
ava_1.default("reaction 初始化不会执行 callback", function (t) {
    var flag = false;
    // tslint:disable-next-line:no-unused-expression
    new index_1.Reaction("test", function () {
        flag = true;
    });
    t.false(flag);
});
ava_1.default("reaction 手动执行", function (t) {
    var flag = false;
    var reaction = new index_1.Reaction("test", function () {
        flag = true;
    });
    reaction.run();
    t.true(flag);
});
ava_1.default("reaction 绑定与构造函数无关，与 track 有关", function (t) {
    var values = [];
    var obj = index_1.observable({
        a: 1,
        b: 2
    });
    var reaction = new index_1.Reaction("test", function () {
        // 使用 a
        values.push(obj.a);
    });
    reaction.track(function () {
        // 绑定的是 b
        // tslint:disable-next-line:no-unused-expression
        obj.b;
    });
    obj.b = 3;
    obj.b = 4;
    obj.a = 8;
    obj.a = 9;
    t.true(values.length === 2);
    t.true(values[0] === 1);
    t.true(values[1] === 1);
});
//# sourceMappingURL=reaction.test.js.map